package lee.whdghks913.examplewebviewallcapture;

import lee.whdghks913.WebViewAllCapture.WebViewAllCapture;
import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Environment;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnLongClickListener;
import android.view.inputmethod.InputMethodManager;
import android.webkit.JsResult;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Toast;

public class MainActivity extends Activity {
    private String mAddress = "http://whdghks913.tistory.com/";
    
    private WebView mWebView;
    private WebSettings mWebSettings;
    private EditText mEditText;
    private ProgressBar mProgressBar;
    private InputMethodManager mInputMethodManager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        mInputMethodManager = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
        
        mEditText = (EditText) findViewById(R.id.addressInput);
        mProgressBar = (ProgressBar) findViewById(R.id.progressBar);
        mWebView = (WebView) findViewById(R.id.webView);
        
        mWebSettings = mWebView.getSettings();
        // setSavePassword(false)   API̱   ʽϴ
//        mWebSettings.setSavePassword(false);
//        mWebSettings.setAppCacheMaxSize(10000);
        mWebSettings.setSaveFormData(false);
        mWebSettings.setJavaScriptEnabled(true);
        mWebSettings.setSupportZoom(true);
        mWebSettings.setBuiltInZoomControls(true);
        mWebSettings.setCacheMode(WebSettings.LOAD_NO_CACHE);
        
        mWebView.setWebChromeClient(new webViewChrome());
        mWebView.setWebViewClient(new webViewClient());
        
        mWebView.setOnLongClickListener(new OnLongClickListener() {
			
			@Override
			public boolean onLongClick(View v) {
				String mFilePath = Environment.getExternalStorageDirectory().getAbsolutePath().toString() + "/AllCapture/";
				String mScreenShotName = "AllCapture_" + System.currentTimeMillis() + ".png";
				
				WebViewAllCapture mAllCapture = new WebViewAllCapture();
				Boolean result = mAllCapture.onWebViewAllCapture(mWebView, mFilePath, mScreenShotName);
				if(result)
					Toast.makeText(MainActivity.this, "ĸĵǾϴ " + mFilePath
							+ mScreenShotName, Toast.LENGTH_LONG).show();
				return true;
			}
		});
        
        mWebView.loadUrl(mAddress);
        mEditText.setText(mAddress);
    }
    
    public void GoButton(View v){
        mInputMethodManager.hideSoftInputFromWindow(mEditText.getWindowToken(), 0);
        mAddress = httpaddressCheck(mEditText.getText().toString());
        
         if(mAddress == null)
             return;
         
         mWebView.loadUrl(mAddress);
         mEditText.setText(mAddress);
    }
    
    private String httpaddressCheck(String inputUrl) {
        if(inputUrl.length()==0)
            return null;
        
        if(inputUrl.indexOf("http://")  != -1)
            return inputUrl;
        
        else return "http://" + inputUrl;
    }
    
    public class webViewChrome extends WebChromeClient {
        
        @Override
        public void onProgressChanged(WebView view, int newProgress) {
            super.onProgressChanged(view, newProgress);
            
            if(newProgress < 100) {
                mProgressBar.setProgress(newProgress);
            }else{
                mProgressBar.setVisibility(View.INVISIBLE);
            }
        }
        
        /**
         * Ȩ  Ǿ ȣ˴ϴ
         * icon Ȩ 
         */
        @Override
        public void onReceivedIcon(WebView view, Bitmap icon) {
            super.onReceivedIcon(view, icon);
        }
        
        /**
         * Ȩ    ȣ˴ϴ
         * title <title>ŸƲ</title>  "ŸƲ" Դϴ
         */
        @Override
        public void onReceivedTitle(WebView view, String title) {
            super.onReceivedTitle(view, title);
        }
        
        /**
         * ڹٽũƮ (˸) ǥ 
         */
        @Override
        public boolean onJsAlert(WebView mView, String url, String message, JsResult result) {
            result.confirm();
            
            return true;
        }
        
        /**
         * ڹٽũƮ Ȯ ȭڸ ǥ 
         */
        @Override
        public boolean onJsConfirm(WebView view, String url, String msg, JsResult result){
            result.confirm();
            
            return true;
        }
    }
    
    public class webViewClient extends WebViewClient {

        @Override
        public void onPageFinished(WebView view, String url) {
            super.onPageFinished(view, url);
            
            mEditText.setText(url);
        }

        @Override
        public boolean shouldOverrideUrlLoading(WebView mView, String url) {
            mProgressBar.setVisibility(View.VISIBLE);
            mView.loadUrl(url);
            
            return super.shouldOverrideUrlLoading(mView, url);
        }
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0){
            if(mWebView.canGoBack()){
                mWebView.goBack();
            }else{
                mWebView.clearCache(false);
                finish();
            }
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
}
